/** Pure LOCF, no accounting for stale values **/
proc sql noprint;
  create table sql_yq as select * from
  qtr as q left join  year (rename=(date=YR_DATE)) as y
  on y.id=q.id   and YR_DATE<=date
  group by q.id,date   having YR_DATE=max(YR_DATE);
quit;

proc compare base=locf_yq_stale compare=sql_yq_stale notes noprint;run;


/* Adding levels to the hierarchy requires subquery expressions */
proc sql ;
  create table sql_yqm as select * from
  month as m left join 
    (select * from qtr (rename=(date=qtr_date)) as q
        left join year (rename=(date=yr_date))  as y
    on y.id=q.id and yr_date<=qtr_date
    group by q.id,qtr_date having yr_date=max(yr_date)
    ) as yq
  on m.id=yq.id  and QTR_DATE<=date
  group by m.id,date having QTR_DATE=max(QTR_DATE);
quit;


proc compare base=locf_yqm_stale compare=sql_yqm_stale notes noprint;run;
