proc sql noprint;
  create table sql_yq_stale as select * from
  qtr_missing as q  left join  year_missing (rename=(date=YR_DATE)) as y
  on y.id=q.id   and   YR_DATE<=date<intnx('year',yr_date,1,'same')
  group by q.id,date   having YR_DATE=max(YR_DATE);
quit;
proc compare data=locf_yq_stale compare=sql_yq_stale notes noprint;run;


/* When you enforce a "stale" regime, using hierarchical subqueries
   it is the lowest-hierarchies join that must be sub-queries */
proc sql noprint;
  create table sql_yqm_stale as select * from
    (select * from month as m left join qtr_missing (rename=(date=QTR_DATE)) as q
     on q.id=m.id and QTR_DATE <= date < intnx('month',qtr_date,3,'same')
     group by m.id,date having QTR_DATE=max(QTR_DATE))
    as qm 
    left join     year_missing (rename=(date=YR_DATE)) as y
    on y.id=qm.id and YR_DATE<=date<intnx('year',yr_date,1,'same')
    group by qm.id,date having YR_DATE=max(YR_DATE)
    ;
quit;

proc compare data=locf_yqm_stale compare=sql_yqm_stale notes noprint;run;
