data locf_yq_stale (drop=_sentinel:);
  merge YEAR_missing  (in=iny keep=id date)
        QTR_missing   (in=inq);
  by id date;
  retain _sentinel1 .;
  if iny then set YEAR_missing (rename=(date=YR_date));  
  retain _sentinel2 .;
  if yr_date^=. and intck('month',yr_date,date)>11
   then call missing(of _sentinel1--_sentinel2);

  if inq then output;
  if last.id then call missing(of _all_); 
run;

data locf_yqm_stale (drop=_sentinel:);
  merge YEAR_missing (in=iny keep=id date)
        QTR_missing  (in=inq keep=id date)
        Month        (in=inm keep=id date);
  by id date;
  retain _sentinel1 .;
  if iny then set YEAR_missing (rename=(date=YR_date));  
  retain _sentinel2 .;
  if inq then set QTR_missing (rename=(date=QTR_date));
  retain _sentinel3 . ;

  if yr_date^=. and intck('month',yr_date,date)>11
   then call missing(of _sentinel1--_sentinel2);
  if qtr_date^=. and intck('month',qtr_date,date)>2
   then call missing(of _sentinel2--_sentinel3);
  if inm then set month;
  if inm then output;
  if last.id then call missing (of _all_);
run;



